# -----(Description)----------------------------------------------------------
# Raw Dir List v1.0 By Darryl Perry, 2003.  A Cyberia BBS Production
#
# Raw Dir List is a Mystic BBS MPL Sysop utility that allows the sysop to
# view the raw directory listing of the current Mystic BBS Filebase.
# This replicates a feature that I found useful in the Telegard BBS package.
# 
# Although this program is entered into the public domain, please give 
# credit where credit is due.  If you use this program, or portions thereof,
# please give due credit.
#
# More information can be found in the Sysop.txt file of the gy-rdl10.zip file
# ---------------------------------------------------------------------------

Uses Cfg
Uses User
Uses Dir
Uses FBase 

Var	FileCnt	Integer
Var	DirCnt	Integer
Var Sizes	LongInt
Var LineCnt	Integer

Function Comma(Str1 String) : String
Var I1	Integer
Var I2	Integer
Var Len	Integer
begin
	Len:=Length(Str1)
	I2:=0
	For I1:=Len downto 1
		I2:=I2+1
		If I2 = 3 and I1 <> 1 Then
			Insert(',',Str1,I1)
			I2:=0
		Endif
	Fend
	Comma:=Str1
Pend

Procedure CheckLines
Begin
	LineCnt:=LineCnt+1
	If LineCnt>21 Then
		Write('|CRPause|PN')
		LineCnt:=1
	Endif
Pend

Begin
	GetCfg
	GetThisUser
	LineCnt:=1
	If GetFBase(UserCurFBase) Then
		WriteLn('|CL|07Directory listing of ' + FBPath)
		CheckLines
		DirCnt:=0
		Findfirst(FBPath+'*',directory)
		While DosError = 0
			If DirName <> '.' and DirName <> '..' Then
				Write('|CR|07 '+PadRt(DateStr(DirTime,1),15,' '))
				Write(PadRt(TimeStr(DirTime,1),10,' '))
				Write(PadRt('<DIR>',26,' ')+'|14'+DirName)
				DirCnt:=DirCnt+1
				CheckLines
			Endif
			FindNext
		Wend
		FindClose
		Filecnt:=0
		Sizes:=0
		Findfirst(FBPath+'*',hidden+sysfile+archive)
		While DosError = 0
			FileCnt:=Filecnt+1
			Sizes:=Sizes+DirSize
			Write('|CR|07 '+PadRt(DateStr(DirTime,1),15,' '))
			Write(PadRt(TimeStr(DirTime,1),10,' '))
			Write(PadLt(Comma(Int2Str(DirSize)),16,' ')+'|15|$D10 '+DirName)
			CheckLines
			FindNext
		Wend
		FindClose
	Endif
	Write('|CR|CR|$D20 Files(s) '+Int2Str(FileCnt) + PadLt(Comma(Int2Str(Sizes)),15,' ') + ' bytes')
	CheckLines
	Write('|CR|$D20 Dir(s)   '+Int2Str(DirCnt))
	CheckLines
	WriteLn('|CR|PA')
End
